/*  SERDAC.C - modul nastaven a obsluhy peruen
	 !!! Jen pro reim DOS !!!
	 Sriov D/A pevodnk na TXR sriovho portu.
	 (C) Ivan Doleal
	 V 1.5
	 27. 3. 1998
*/

#pragma  inline	// obsahuje inline asembler, kompilace pres TurboAssembler

#include <dos.h>
#include "comdac.h"

int
	portbase = 0,	// bzov adresa COM portu
	int_no,			// slo peruen pro COM adaptr
	irq_mask,		// maska povolen pslunho peruen
	oldMCR,			// uchovan pvodn hodnota MCR
	oldIMR;
void interrupt (*oldcomvect)();	// uchovan pvodn vektor peruen pro COM
unsigned
	dacbyte = 0x55,	// trvale vzslan bajt
	acc = 0,				// akumultor pro generovn PDM
	value = 0;			// hodnota, pevdn DAC
int intrflag=0;		// vlajka - zavedeno peruen od COM
volatile int done=0;	// vlajka - ukonen vstup zvuku
unsigned long is;		// ta vzork zvuku
int huge *ip;			// ukazatel v buferu vzork zvuku

//***************************
void interrupt com_dac_int()
{
asm {
	 mov   dx,(value)
	 mov   bx,(acc)
	 xor   ax,ax
	 mov   cx,8       }	// ta cyklu - 8 bit
nextbit:  asm        {
	 add   bx,dx			// souet modulo 2^16 akumultoru 'ACC' a hodnoty
	 rcr   al,1				// bit penosu (peteen) -> AL (MSB)
	 loop  nextbit
	 mov   (acc),bx		// uchovn postupnho soutu
	 mov   dx,(portbase)
	 out   dx,al			// vstup vsledku pevodu (8 bit) do TXR
	 mov   al,EOI
	 out   ICR,al
	 }
}

//***************************
void interrupt com_play_int()
{
value = (unsigned int)(*ip++ + 32768);	// pevod vzorku z buferu na UNSIGNED
asm {
	 mov   dx,(value)
	 mov   bx,(acc)
	 xor   ax,ax
	 mov   cx,8       }
nextbit:  asm        {
	 add   bx,dx
	 rcr   al,1
	 loop  nextbit
	 mov   (acc),bx
	 mov   dx,(portbase)
	 out   dx,al
	 }
if (--is == 0)  done=1;		// nastaven vlajky pi poslednm vzorku
outportb(ICR,EOI);			// signl o ukonen obsluhy adii peruen
}

//***************************
// Rutina obsluhy peruen COM pro vstup konstantnho bajtu 'dacbyte'
void interrupt byte_int()
{
asm {
	 mov   al,BYTE PTR dacbyte
	 mov   dx,(portbase)
	 out   dx,al
	 mov   al,EOI
	 out   ICR,al
	 }
}

/***************************/
// Nastaven pomocnch signl COM (nap. pro napjen pipojench modul)
void setrtsdtr(int setting)
{
int mcr0;
mcr0 = inportb(portbase + MCR);	// peten pvodn stav
outportb( portbase + MCR, (mcr0 & ~(RTS|DTR)) | I_ENABLE | setting & 0x3 );
}

/***************************/
// Nastaven linky na trvalou rove
void settxr(int bool)
{
outportb( portbase + LCR, (bool) ? 0x03 : 0x43 );
}

/***************************/
// Nastaven libovoln penosov rychlosti (BR...baud rate) COM adaptru
// BR = 115200 / divisor
void setbaudrate(unsigned divisor)
{
char  c;
if (divisor == 0)
	divisor = 1;                           // oeten nulovho dlitele
disable();
c = inportb(portbase + LCR);					// ten pvodniho stavu LCR
outportb(portbase + LCR, (c | 0x80));		// nastaven bitu DLAB
outportb(portbase + DLL, BLO(divisor));   // nastaven ni bajt dlitele
outportb(portbase + DLH, BHI(divisor));	// nastaven vy bajt dlitele
outportb(portbase + LCR, c);					// nulovn bitu DLAB */
enable();
return;
}

/***************************/
void com_on( void interrupt (*int_vect)() )
{
if (intrflag)  return;
oldcomvect = getvect(int_no);			// uchovn starho vektoru peruen
setvect(int_no, int_vect);				// nastaven novho vektoru
disable();
outportb( portbase + LCR, 0x03 );	// 8 data bits, no parity, 1 stop bit
oldMCR = inportb(portbase + MCR);
outportb( portbase + MCR, oldMCR | I_ENABLE);	// povolen vstupu peruen na COM
inportb(portbase + IIR);				// reset IIR
outportb( portbase + IER, TR_INT );	// nastaven udlosti, generujc peruen
oldIMR = inportb(IMR);
outportb( IMR, ~(IRQ(1) | irq_mask) );	// povoleno peruen od COM na adii
intrflag = 1;
outportb( portbase + TXR, 0x55 );		// vstup pro vyvoln prvnho peruen
enable();
}

/***************************/
void com_off(void)
{
if (! intrflag) return;
disable();
outportb( IMR, oldIMR );      			// pvodn stav na adii peruen
outportb( portbase + IER, 0 );
outportb( portbase + MCR, oldMCR );		// pvodn nastaven
enable();
setvect(int_no, oldcomvect);				// obnoven vektoru peruen
intrflag = 0;
}

/***************************/
int setportpar(int port)
{
int far *biosadr;
switch (port)
	{
	case  1 :  int_no = 0x0C;  irq_mask = IRQ(4);  break;   // COM1
	case  2 :  int_no = 0x0B;  irq_mask = IRQ(3);  break;   // COM2
	case  3 :  int_no = 0x0C;  irq_mask = IRQ(4);  break;   // COM3
	case  4 :  int_no = 0x0B;  irq_mask = IRQ(3);  break;   // COM4
	default :  return(-1);                                  // chybn slo COM
	}
biosadr = (int far *)MK_FP( 0x0040, 2*(port-1) );	// ten adresy COM z BIOS oblasti RAM
if (*biosadr == 0L)
	return (-1);			// nen-li port instalovn
portbase = *biosadr;
return (0);
}
