/*	 COMDAC.H - hlavikov soubor
	 Sriov D/A pevodnk na TXR sriovho portu.
	 Praktick elektronika A Radio .5/98
	 (C) Ivan Doleal
	 V 1.5
	 27. 3. 1998
*/

/* COM - Posuv adres vybranch registr vi bzov adrese   */
#define TXR    0     /* Transmit register (WRITE)            */
#define DLL    0     /* Divisor Latch Low                    */
#define DLH    1     /* Divisor Latch High                   */
#define IER    1     /* Interrupt Enable Register            */
#define IIR    2     /* Interrupt Identification Register    */
#define LCR    3     /* Line Control Register                */
#define MCR    4     /* Modem Control Register               */

/* COM: vybran bity MCR */
#define DTR          0x01
#define RTS          0x02
#define I_ENABLE     0x08    /* Povolen signlu peruen od COM portu */

/* COM: vybran bit IER */
#define TR_INT       0x02

/* COM: vybran bity IIR */
#define TR_ID        0x02
#define INT_MASK     0x07

/* PIC 8259 - registry a kdy adie peruen */
#define IMR          0x21     /* Interrupt Mask Register */
#define ICR          0x20     /* Interrupt Control Register */
#define EOI          0x20     /* End Of Interrupt */
#define IRQ(n)       (1<<n)   /* maska peruen */

#define ESC          0x1B     /* kd klvesy */

#define U_0          5.000
#define U_MAX       -5.000
#define DU_MAX      (U_0 - U_MAX)

#define  BLO(x)  *((unsigned char *)&(x))
#define  BHI(x)  *(((unsigned char *)&(x))+1)

void interrupt com_dac_int();
void interrupt com_play_int();
void interrupt byte_int();
void interrupt byte_int();
void com_on( void interrupt (*int_vect)() );
void com_off(void);
int setportpar(int port);
void setbaudrate(unsigned divisor);
void setrtsdtr(int setting);
void settxr(int bool);
