/*  COMDACM.C - modul hlavnho programu
	 Sriov D/A pevodnk na TXR sriovho portu.
	 Praktick elektronika A Radio .5/98
	 (C) Ivan Doleal
	 V 1.5
	 27. 3. 1998
*/

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include "comdac.h"

extern int portbase;
extern unsigned value, dacbyte;
extern volatile int done;
extern unsigned long is;
extern int huge *ip;

int port;						// slo portu 1...4
unsigned char fbuf[16384];	// bufer pro ten souboru se vzorkyz zvuku

/***************************/
int main( int argc, char *argv[] )
{
FILE *fp;
float u, v;
char entbuf[43], *fn, *format;
unsigned brdiv = 12;
unsigned br[9] = { 1, 2, 3, 6, 12, 24, 48, 96, 192 };	// pedvolen dlitele
int aux, c, fh;
unsigned int ib;
unsigned long fl, ns;
unsigned char far *mp, huge *imp;

cputs("\n\r- COMDACM - V1.5 - Seriovy D/A prevodnik na COM port - (C) I. Dolezal 1996,98 -");
if (argc > 1)					// 1. dkov parametr ... . COM portu
	port = atoi(argv[1]);
else
	{  cputs("\n\rChybi parametr - cislo portu COM (1,2,3,4) !\n\r\a");  exit(1);  }
if (argc > 2)					// 2. dkov parametr ... . dlitele baud rate
	brdiv = atoi(argv[2]);
if ( setportpar(port) )
	{  cputs("\n\rZvoleny port neni instalovan !\n\r\a");  exit(1);  }
cprintf("\n\rPort COM%1d                                               Bezi jen v rezimu DOS !",
		port);
setrtsdtr(DTR);				// nastaven vstupu pro napjen modulu (RTS+,DTR-)
setbaudrate(brdiv);
cprintf("\n\rBaud rate = %lu Bd\n\r", 115200L/brdiv);
while (1)
	{
	cputs("\n\rStiskni klavesu ( 1-znakovy povel, <ESC>ape, <?> help ) : ");
	switch ( c=toupper(getche()) )
		{
		case '?' :
			cputs("\n\n\rRadkove argumenty : SERDAC  com#  [BR_div]"
					"\n\r   com#   ... cislo COM portu : 1,2,3,4"
					"\n\r   BR_div ... delitel pro nastaveni kmitoctu pulsu 115200/BR_div Hz : 1...65535"
					"\n\rKlavesy <key> :"
					"\n\r   <R>ate  ... nastav kmitocet pulsu (baud rate BR)"
					"\n\r   <V>alue ... nastav unsigned integer hodnotu vystupu DAC"
					"\n\r   <B>yte  ... nastav konstantni bajt XX, opakovane vysilany"
					"\n\r   <U>     ... nastav vystupni napeti DAC"
					"\n\r   <L>ow   ... linka trvale L, t.j. -napeti na vystupu modulu"
					"\n\r   <H>igh  ... linka trvale H, t.j. +napeti na vystupu modulu"
					"\n\r   <F>ile  ... nacti binarni soubor a posli na vystup"
					"\n\r   cislice ... rychla volba baud rate : 1 = max, ... 9 = min"
					"\n\r   <+>     ... bajt XX = FFh"
					"\n\r   <->     ... bajt XX = 00h"
					"\n\r   <=>     ... bajt XX = 55h, t.j. 0, stredni vystup"
					"\n\r");
			break;
		case 'R' :
			while (1)
				{
				cputs("\n\rZadej delitel pro Baud Rate (1...65535) nebo nic (pro ukonceni) : ");
				entbuf[0] = 40;
				cgets(entbuf);
				if (entbuf[1]==0)  break;
				aux = atoi(entbuf+2);
				if (aux > 0)
					{  brdiv = aux;  setbaudrate(brdiv);
						cprintf("\n\rBaud rate = %lu Bd", 115200L/brdiv);
						break;  }
				}
			break;
		case 'V' :
			com_off();
			com_on(com_dac_int);
			while (1)
				{
				cputs("\n\r   Zadej hodnotu 0...65535, 0x0...0xffff nebo nic (pro ukonceni) : ");
				entbuf[0] = 40;
				cgets(entbuf);
				if (entbuf[1]==0)
					break;
				if ( strchr(entbuf+2,'x') || strchr(entbuf+2,'X') )
					format = "%x";
				else
					format = "%u";
				sscanf( entbuf+2, format, &value );
				}
			com_off();
			break;
		case 'U' :
			com_off();
			com_on(com_dac_int);
			while (1)
				{
				cputs("\n\r   Zadej napeti ( -5.000 .. +5.000 V ) nebo nic (pro ukonceni) : ");
				entbuf[0] = 40;
				cgets(entbuf);
				if (entbuf[1]==0)
					break;
				sscanf( entbuf+2, "%f", &u );
				v = (u + U_0)/DU_MAX * 65536.0;
				if (v < 0.0) v = 0.0;
				if (v > 65535.0) v = 65535.0;
				value = (unsigned)v;
				cprintf("\n\r   Value = %u",value);
				}
			com_off();
			break;
		case 'B' :
			com_on(byte_int);
			while (1)
				{
				cputs("\n\r   Zadej trvale vysilany hexa byte nebo nic (pro ukonceni) : ");
				entbuf[0] = 40;
				cgets(entbuf);
				if (entbuf[1]==0)
					break;
				sscanf( entbuf+2, "%x", &dacbyte );
				}
			com_off();
			break;
		case 'F' :
				com_off();
				cputs("\n\r   Zadej cele jmeno binarniho souboru nebo nic (pro ukonceni) :\n\r");
				entbuf[0] = 40;
				cgets(entbuf);
				if (entbuf[1]==0)
					break;
				fn = strupr(entbuf+2);
				if ((fp=fopen(fn,"rb")) == NULL)
					cprintf("\a\n\r   Chybne jmeno souboru %s !", fn);
				else
					{
					fh = fileno(fp);
					fl = filelength(fh);
					mp = (unsigned char far *)farmalloc(fl+2);	// alokace bloku na FAR HEAP
					if (mp==NULL)
						{  cputs("\a\n\r   Prilis dlouhy soubor - nevejde se do pameti !");
							fclose(fp);	}
					else if (fl < 2)
						{  cputs("\a\n\r   Soubor ma mene nez 2 bajty !");
							fclose(fp);	}
					else
						{
						ns = 0;
						imp = mp;
						do {  		// naten binrnho souboru do FAR HEAP
							ib = fread((void *)fbuf, 1, sizeof(fbuf), fp);
							_fmemcpy( (void far *)imp, (void far *)fbuf, ib );
							imp += ib;
							ns += ib/2;
							}
						while (ib==sizeof(fbuf));
						fclose(fp);
						cprintf("\n\r   Delka souboru %lu vzorku.\n\r"
							"Prehravani souboru ...", ns );
						ip = (int huge *)mp;
						is = ns;
						done = 0;
						c = 0;
						com_on(com_play_int);		// prehrani zvuku
						while ( ! done )
							if (kbhit())	{  c=getch();  break;  }
						com_off();
						if (c)
							cputs("\n\r   ... bylo preruseno.");
						else
							cputs("\n\r   ... skoncilo.");
						farfree(mp);
						}
					}
				break;
		case '-' : dacbyte = 0;		com_on(byte_int);	break;
		case '+' : dacbyte = 0xFF;	com_on(byte_int);	break;
		case '=' : dacbyte = 0x55;	com_on(byte_int);	break;
		case 'L' : com_off();	settxr(0);	break;
		case 'H' : com_off();	settxr(1);  break;
		case ESC : goto endm;
		default	: aux = c - '1';
						if ( aux >= 0 && aux < 10 )
							{
							brdiv = br[aux];
							setbaudrate(brdiv);
							cprintf("\n\rBaud rate = %lu Bd", 115200L/brdiv);
							}
		}
	}
endm:
com_off();
cputs("\n\n\rKonec programu COMDACM.\n\r");
return (0);
}
